题目描述

牛牛最近迷上了一种叫斗地主的扑克游戏。斗地主是一种使用黑桃、红心、梅花、方片的A到K加上大小王的共54张牌来进行的扑克牌游戏。在斗地主中,牌的大小关系根据牌的数码表示如下:3<4<5<6<7<8<9<10<J<Q<K<A<2<小王<大王,而花色并不对牌的大小产生影响。每一局游戏中,一副手牌由n张牌组成。游戏者每次可以根据规定的牌型进行出牌,首先打光自己的手牌一方取得游戏的胜利。

现在,牛牛只想知道,对于自己的若干组手牌,分别最少需要多少次出牌可以将它们打光。请你帮他解决这个问题。

需要注意的是,本题中游戏者每次可以出手的牌型与一般的斗地主相似而略有不同。

具体规则如下:

输入输出格式

输入格式:

第一行包含用空格隔开的2个正整数T和n,表示手牌的组数以及每组手牌的张数。

接下来T组数据,每组数据n行,每行一个非负整数对aibi表示一张牌,其中ai示牌的数码,bi表示牌的花色,中间用空格隔开。特别的,我们用1来表示数码A,11表示数码J,12表示数码Q,13表示数码K;黑桃、红心、梅花、方片分别用1-4来表示;小王的表示方法为01,大王的表示方法为02。

输出格式:

共T行,每行一个整数,表示打光第i手牌的最少次数。

输入输出样例

输入样例#1:

1 8
7 4
8 4
9 1
10 4
11 1
5 1
1 4
1 1
输出样例#1:

3
输入样例#2:

1 17
12 3
4 3
2 3
5 4
10 2
3 3
12 2
0 1
1 3
10 1
6 2
12 1
11 3
5 2
12 4
2 2
7 2
输出样例#2:

6

说明

样例1说明

共有1组手牌,包含8张牌:方片7,方片8,黑桃9,方片10,黑桃J,黑桃5,方片A以及黑桃A。可以通过打单顺子(方片7,方片8,黑桃9,方片10,黑桃J),单张牌(黑桃5)以及对子牌(黑桃A以及方片A)在3次内打光。

对于不同的测试点, 我们约定手牌组数T与张数n的规模如下:

数据保证:所有的手牌都是随机生成的。

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm> using namespace std;
int x[],y[],z[],k[],num[];
int T,cnt,flag,n; bool cmp(int a,int b)
{
return a>b;
} int main()
{
scanf("%d%d",&T,&n);
while(T--)
{
flag=,cnt=;
memset(z,,sizeof z);
memset(x,,sizeof x);
memset(num,,sizeof num);
if(n>) return ;
for(int i=;i<=n;i++)
{
scanf("%d%d",&x[i],&y[i]);
num[x[i]]++;
}
for(int i=;i<=;i++)
{
if(num[i]!=)
z[++cnt]=num[i];
}
sort(z+,z+n+,cmp);
if(z[]==)
{
cout<<n<<endl;
continue;
}
if(z[]==n)
{
cout<<""<<endl;
continue;
}
if(z[]==)
{
cout<<""<<endl;
continue;
}
if((z[]==&&z[]==))
{
cout<<""<<endl;
continue;
}
if((z[]==&&z[]==&&z[]==))
{
cout<<""<<endl;
continue;
}
if(n==&&z[]==)
{
cout<<""<<endl;
continue;
}
}
return ;
}

最无脑的暴力30分...

dfs+贪心

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
using namespace std;
int T,n,num[],ans,p[];//num代表第i种牌有几个,p代表剩下i张的牌有几种 void rest(int x,int u)
{
int temp=u;
bool flag=false;
if (num[]&&num[]) flag=true;//是否有王炸
memset(p,,sizeof(p));
for (int i=; i<=; i++) p[num[i]]++;
if (p[]!=) //四牌特判
{
temp+=p[];
if (p[]>=p[]*) p[]-=p[]*;//对子够用,四带二
else //对子不够,单张上,四帯一
{
p[]-=p[]/;
p[]=p[]%;
if (p[]>=p[]*) p[]-=p[]*;
else p[]=p[]%;
}
}
if (p[]!=) //同炸弹
{
temp+=p[];
if (p[]>=p[]) p[]-=p[];
else
{
p[]-=p[];
p[]=;
if (p[]>=p[]) p[]-=p[];
else p[]=;
}
}
if (p[]!=) temp+=p[];
if (p[]>=&&flag) temp+=p[]-;
else temp+=p[];//如果单张剩余2张以上,又存在王炸,那么就把两张单张当成王炸出掉。
ans=min(ans,temp);
return;
}
void dfs(int x,int u)//剩余x张牌,已经用了u步
{
if (u>=ans) return;//剪枝
if (x==)
{
ans=min(u,ans);
return;
}
int start=,end=;
//------单顺-------------
if (x>=)
{
//每个搜顺子开头都有的小剪枝
for (int i=; i<=; i++) //注意只能搜到A
{
if (num[i-]==) start=i;//上一张不够牌,所以这张开始做顺头
if (num[i]!=) end=i;//这张是够的,所以顺尾后移
if (end-start+>=) //如果牌够了
{
for (int k=; k<=end-start+; k++)
{
//要记得start也可以后移,不然一直只能以start开始顺子,直到start改变
start+=k-;//我就是这里写错调了好久。。。
for (int j=start; j<=end; j++) num[j]--;
dfs(x-(end-start+),u+);
for (int j=start; j<=end; j++) num[j]++;
start-=k-;
}
}
}
}
start=;
end=;
//------双顺-------------
if (x>=) //全部同单顺
{
for (int i=; i<=; i++)
{
if (num[i-]<=) start=i;
if (num[i]>) end=i;
if (end-start+>=)
{
for (int k=; k<=end-start+; k++)
{
start+=k-;
for (int j=start; j<=end; j++) num[j]-=;
dfs(x-(end-start+)*,u+);
for (int j=start; j<=end; j++) num[j]+=;
start-=k-;
}
}
}
}
start=;
end=;
//------san shun-------------
if (x>=)
{
for (int i=; i<=; i++)
{
if (num[i-]<=) start=i;
if (num[i]>) end=i;
if (end-start+>=)
{
for (int k=; k<=end-start+; k++)
{
start+=k-;
for (int j=start; j<=end; j++) num[j]-=;
dfs(x-(end-start+)*,u+);
for (int j=start; j<=end; j++) num[j]+=;
start-=k-;
}
}
}
}
rest(x,u);//贪心
return;
}
int main()
{
scanf("%d%d",&T,&n);
for (int qwe=; qwe<=T; qwe++)
{
memset(num,,sizeof(num));
ans=0x3f3f3f3f;//重要的初始化
for (int i=; i<=n; i++)
{
int a,b;
scanf("%d%d",&a,&b);//花色没用,仅仅在大小王上有用
if (a==)
{
if (b==) num[]++; //大小王视为单张。。。
if (b==) num[]++;
}
else
{
if (a==) num[]++;
else if (a==) num[]++;
else num[a-]++;//3->1 4->2 ..... K->11 A->12 2->13 这里是方便搜顺子
}
}
dfs(n,);
printf("%d\n",ans);
}
return ;
}
//我真的好笨...... 就不想写dfs,就是不对! 唉......
#include<iostream>
#include<cstdio>
#include<cstring> #define maxn 50 using namespace std;
int poker_cnt[maxn],poker_now[maxn];
int x,y,t,n,ans,cnt,num,pos,start,flag,flag_2,c; inline int init()
{
int x=,f=;char c=getchar();
while(c>''||c<''){if(c=='-')f=-;c=getchar();}
while(c>=''&&c<=''){x=x*+c-'';c=getchar();}
return x*f;
} void work1()
{
for(int i=;i<=;i++)
{
if(poker_cnt[i+]&&poker_cnt[i])
{
cnt=;start=i;pos=i;
while(poker_cnt[pos]&&pos<=){cnt++;pos++;}
if(cnt>=)
{
for(int j=start;j<=start+cnt-;j++)poker_cnt[j]--;
n-=cnt;ans++;
}
}
}
} void work2()
{
flag=;
for(int i=;i<=;i++)
{
flag_2=;int pd1=,pd2=,pos2=;
if(poker_cnt[i]==)
{
for(int j=;j<=;j++) for(int k=;k<=;k++)
{
if(poker_cnt[j]>=&&poker_cnt[k]>=&&k!=j&&!flag_2)
{
flag=;
if(poker_cnt[j]==) pd1=k;if(poker_cnt[k]==) pd1=j;
for(int l=;l<=;l++)
if(poker_cnt[l]==&&l!=pd1) pd2=,pos2=l;
if(!pd2)poker_cnt[k]--,poker_cnt[j]--,poker_cnt[i]-=;
else poker_cnt[pd1]--,poker_cnt[pos2]--,poker_cnt[i]-=;
n-=;ans++;flag_2=;
}
if(poker_cnt[j]==&&poker_cnt[k]==&&k!=j&&!flag_2)
{
flag=;
poker_cnt[k]-=;poker_cnt[j]-=;poker_cnt[i]-=;
n-=;ans++;flag_2=;
}
}
if(!flag) poker_cnt[i]-=,n-=,ans++;
}
}
} void work3()
{
for(int i=;i<=;i++)
{
if(poker_cnt[i]==&&poker_cnt[i+]==)
{
start=i;pos=i;cnt=;
while(poker_cnt[pos]==){cnt++;pos++;}
if(cnt>=)
{
n-=cnt*;ans++;
for(int i=start;i<=cnt+start-;i++) poker_cnt[i]-=;
}
}
if(poker_cnt[i]==&&poker_cnt[i+]==)
{
start=i;pos=i;cnt=;
while(poker_cnt[pos]==){cnt++;pos++;}
if(cnt>=)
{
n-=cnt*;ans++;
for(int i=start;i<=cnt+start-;i++) poker_cnt[i]-=;
}
}
}
} void work4()
{
flag=;
for(int i=;i<=;i++)
{
flag_2=;
if(poker_cnt[i]==)
{
for(int j=;j<=;j++)
{
if(poker_cnt[j]==&&!flag_2)
{
flag=;
poker_cnt[j]--;poker_cnt[i]-=;
n-=;ans++;flag_2=;
}
}
if(!flag) poker_cnt[i]-=,n-=,ans++;
}
}
} inline void work5()
{
for(int i=;i<=;i++)
{
if(poker_cnt[i])
{
n-=poker_cnt[i];ans++;
poker_cnt[i]=;
}
}
} int main()
{
freopen("landlords8.in","r",stdin);
// freopen("landlords.out","w",stdout);
t=init();n=init();c=n;int d=n;
while(t--)
{
c=d;n=d;
flag=;ans=;memset(poker_cnt,,sizeof poker_cnt);
pos=;start=;memset(poker_now,,sizeof poker_now);
while(c--){x=init();y=init();poker_cnt[x]++;}
poker_cnt[]=poker_cnt[];poker_cnt[]=poker_cnt[];poker_cnt[]=poker_cnt[];
for(int i=;i<=;i++) poker_cnt[i-]=poker_cnt[i];poker_cnt[]=;
poker_cnt[]=;poker_cnt[]=;
if(n>=) work1();//顺子
if(n>=) work2();//四张牌与四带二
if(n>=) work3();//连对,三连对
if(n>=) work4();//三带一
if(n) work5();//单 对牌
if(n==) printf("%d\n",ans);
}
}

2017 5.20 35分

洛谷P2668斗地主(搜索)noip2015的更多相关文章

  1. 洛谷P2668 斗地主==codevs 4610 斗地主[NOIP 2015 day1 T3]

    P2668 斗地主 326通过 2.6K提交 题目提供者洛谷OnlineJudge 标签搜索/枚举NOIp提高组2015 难度提高+/省选- 提交该题 讨论 题解 记录 最新讨论 出现未知错误是说梗啊 ...

  2. [NOIP2015] 提高组 洛谷P2668 斗地主

    题目描述 牛牛最近迷上了一种叫斗地主的扑克游戏.斗地主是一种使用黑桃.红心.梅花.方片的A到K加上大小王的共54张牌来进行的扑克牌游戏.在斗地主中,牌的大小关系根据牌的数码表示如下:3<4< ...

  3. 洛谷P2668 斗地主 [NOIP2015]

    题目描述 牛牛最近迷上了一种叫斗地主的扑克游戏.斗地主是一种使用黑桃.红心.梅花.方片的A到K加上大小王的共54张牌来进行的扑克牌游戏.在斗地主中,牌的大小关系根据牌的数码表示如下:3<4< ...

  4. 洛谷P2668 斗地主

    好,终于搞完了这一道毒瘤题...... 先想到搜索,然后想到状压,发现数据组数很多,又是随机,还是决定用搜索. 先搜出的多的,于是顺序是三个顺子,然后按照多到少搜带牌,最后是不带牌. 大体思路很简单, ...

  5. 洛谷 P2668 斗地主

    毒瘤题目,搞了三天-- 也没什么好讲的,就是纯搜索,先搜顺子,再搜其他的,最后单张牌和对子的时候,就不要搜索了,直接枚举,不然会T飞掉多么痛的领悟-- 主要还是靠码力 #include<iost ...

  6. 洛谷—— P2668 斗地主

    https://www.luogu.org/problem/show?pid=2668 题目描述 牛牛最近迷上了一种叫斗地主的扑克游戏.斗地主是一种使用黑桃.红心.梅花.方片的A到K加上大小王的共54 ...

  7. Luogu P2668 斗地主(NOIP2015)

    还记得那道我只用特判得了30分的"斗地主"吗? 我今天脑抽打算把它改A掉.为什么不用这大好时光去干些更有意义的事 于是我就挖了这个坑. 题解: 题目链接:P2668 斗地主 本题就 ...

  8. P5198 [USACO19JAN]Icy Perimeter S (洛谷) (水搜索)

    同样是因为洛谷作业不会写…… 写(水)博客啦. 直接放题目吧,感觉放在代码框里好看点 Farmer John要开始他的冰激凌生意了!他制造了一台可以生产冰激凌球的机器,然而不幸的是形状不太规则,所以他 ...

  9. 题解【洛谷P2668】[NOIP2015]斗地主

    题目描述 牛牛最近迷上了一种叫斗地主的扑克游戏.斗地主是一种使用黑桃.红心.梅花.方片的 $ A $ 到 $ K $ 加上大小王的共 $ 54 $ 张牌来进行的扑克牌游戏.在斗地主中,牌的大小关系根据 ...

随机推荐

  1. Bullet:关于ORACLE中的HASH JOIN的参数变化

    Oracle在7.3引入了hash join. 但是在Oracle 10g及其以后的Oracle数据库版本中,优化器,实际是CBO,也是因为HASH JOIN仅适用于CBO,在解析目标SQL时是否考虑 ...

  2. 洛谷——P1404 平均数

    P1404 平均数 题目描述 给一个长度为n的数列,我们需要找出该数列的一个子串,使得子串平均数最大化,并且子串长度>=m. 前缀和+二分答案 #include<iostream> ...

  3. 57.fielddata预加载机制以及序号标记预加载

    如果真的要对分词的field执行聚合,那么每次都在query-time的同时由es生成fielddata并加载到内存中来,速度可能会比较慢,性能很差,改善性能的方式就是预先生成fielddata值并加 ...

  4. 后台工具screen

    之前在putty之类的远程命令行操作服务器的时候,遇到关闭软件,对应的操作就会关闭.很多时候,就是开着电脑,然后挂在那里,虽然不用电脑跑,但是也耗电...主要是putty这些软件有时候会伴随黑屏崩掉. ...

  5. 【转】sizeof()用法总结

    传送门:https://blog.csdn.net/u011677209/article/details/52837065

  6. 吧,其实spring自带的BeanUtils就有这样的功能,引入spring-beans和spring-core之后,就有BeanUtils.copyProperties(a, b);可以实现两个javabean之间的相互拷贝,自己写的就当是研究咯---https://www.cnblogs.com/NieXiaoHui/p/7150928.html

    吧,其实spring自带的BeanUtils就有这样的功能,引入spring-beans和spring-core之后,就有BeanUtils.copyProperties(a, b);可以实现两个ja ...

  7. 复习1背包dp

    背包问题是对于一个有限制的容器,一般计算可以装的物品的价值最值或数量.通常每个物品都有两个属性空间和价值,有时还有数量或别的限制条件,这个因体而异. 背包大概分成3部分,下面会细述这最经典的3种题型 ...

  8. pt工具加字段脚本

    #!/bin/bashcnn_db=$1table=$2alter_conment=$3 cnn_host='192.168.10.14'cnn_user='root'cnn_pwd='123456' ...

  9. Ubuntu 16.04安装Chrome浏览器

    一.先有一个hosts能访问Google 参考:http://www.cnblogs.com/EasonJim/p/5999060.html 二.安装方法有两种,如下所示: 1.下载deb包(推荐) ...

  10. memory management in oracle 11G R2

    When we talking about memory management in Oracle, we are refering to SGA and PGA. The management me ...